% Main
N= 40 ;
C = 1.7 ;
A = rand(N,N) + C*eye(N);
U = triu(A) ;
A = U + U' ;


x = ones(N,1) ;
b = A*x ;


x0 = zeros(N,1) ;
itmax = 1000 ;
epsi = 1.e-06 ;

% Jacobi
t0 =tic ;
[y, it, err] = jacobi(x0,A,b, itmax,epsi);
T = toc(t0) ;
sprintf('Jacobi Err= %g  with %d iterations; cost = %g', norm(y-x), it,T)

% Gauss-Seidel
t0 =tic ;
[y, it, err] = gsl(x0,A,b, itmax,epsi);
T = toc(t0) ;
sprintf('gsl Err= %g  with %d iterations; cost = %g', norm(y-x), it,T)

% Richardson
t0 =tic ;
[y, it, err] = richardson(x0,A,b, rho,  itmax,epsi);
T = toc(t0) ;
sprintf('richardson Err= %g  with %d iterations; cost = %g', norm(y-x), it,T)

% SOR
t0 =tic ;
[y, it, err] = sor(x0,A,b, om,  itmax,epsi);
T = toc(t0) ;
sprintf('sor Err= %g  with %d iterations; cost = %g', norm(y-x), it,T)

% Steepest Descent
t0 =tic ;
[y, it, err] = StD(x0,A,b,  itmax,epsi);
T = toc(t0) ;
sprintf('StD Err= %g  with %d iterations; cost = %g', norm(y-x), it,T)

% Conjugate Gradient
t0 =tic ;
[y, it, err] = conjgrad(x0,A,b, itmax,epsi);
T = toc(t0) ;
sprintf('conjgrad Err= %g  with %d iterations; cost = %g', norm(y-x), it, T)






